<?php
/*
  quickpay4.php

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2005 Jakob Hy Biegel

  Released under the GNU General Public License
  
  Process online payment using Quickpay payment class.
*/
  function get_quickpay_api_supported() {
    $qp = new quickpay;
    return $qp->init();
  }

  function get_quickpay_status($order_id) {

  try {
    $qp = new quickpay;
    // Set values
    $qp->set_msgtype('status');
    $qp->set_merchant(MODULE_PAYMENT_QUICKPAY_SHOPID);
    $qp->set_transaction(get_transactionid($order_id));
    $qp->set_md5checkword(MODULE_PAYMENT_QUICKPAY_MD5WORD);
    // Commit the status request
    $eval = $qp->status();
  } catch (Exception $e) {
      // Print error message
      echo "QuickPay Error: Caught an exception in 
          " . $e->getFile() . " at line 
          " . $e->getLine() . "<br />
          " . $e->getMessage() . "<br />";
  }
    return $eval;
  }  
  

  function get_quickpay_reverse($order_id) {
    global $messageStack;
    
  try {
    $qp = new quickpay;
    // Set values
    $qp->set_msgtype('1420');
    $qp->set_merchant(MODULE_PAYMENT_QUICKPAY_SHOPID);
    $qp->set_transaction(get_transactionid($order_id));
    $qp->set_md5checkword(MODULE_PAYMENT_QUICKPAY_MD5WORD);
    // Commit the reversal
    $eval = $qp->reverse();
  } catch (Exception $e) {
      // Print error message
      echo "QuickPay Error: Caught an exception in 
          " . $e->getFile() . " at line 
          " . $e->getLine() . "<br />
          " . $e->getMessage() . "<br />";
  }

    $result = 'QuickPay Reverse: ';
    if ($eval) {
      if ($eval['qpstat'] === '000') {
          // The reversal was completed
          $result .= 'Succes: ' . $eval['qpstatmsg'];
          $messageStack->add_session($result, 'success');
          return true;
      } else {
          // An error occured with the reversal
          $result .= 'Failure: ' . $eval['qpstatmsg'];
          $messageStack->add_session($result, 'warning');
          return false;
      }
    }
    // Communication error
    $result .= 'Failed: Communication Error'; 
    $messageStack->add_session($result, 'warning');
    return false;
  }  

  
  function get_quickpay_capture($order_id, $amount) {
    global $messageStack;

/*
    $orderstotal_query = tep_db_query("select value  from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . (int)$order_id . "' and class = 'ot_total'");
    $orderstotal = tep_db_fetch_array($orderstotal_query);
*/        
  try {
    $qp = new quickpay;
    // Set values
    $qp->set_msgtype('1220');
    $qp->set_md5checkword(MODULE_PAYMENT_QUICKPAY_MD5WORD);
    $qp->set_merchant(MODULE_PAYMENT_QUICKPAY_SHOPID);
    $qp->set_transaction(get_transactionid($order_id));
    $qp->set_amount($amount /*$orderstotal['value']*/);
    // Commit the capture
    $eval = $qp->capture();
  } catch (Exception $e) {
      // Print error message
      echo "QuickPay Error: Caught an exception in 
          " . $e->getFile() . " at line 
          " . $e->getLine() . "<br />
          " . $e->getMessage() . "<br />";
  }

    $result = 'QuickPay Capture ';
    if ($eval) {
      if ($eval['qpstat'] === '000') {
          // The reversal was completed
          $result .= 'Succes: ' . $eval['qpstatmsg'];
          $messageStack->add_session($result, 'success');
          return true;
      } else {
          // An error occured with the reversal
          $result .= 'Failure: ' . $eval['qpstatmsg'];
          $messageStack->add_session($result . ' : ' . $amount, 'warning');
          return false;
      }
    }
    // Communication error
    $result .= 'Failed: Communication Error'; 
    $messageStack->add_session($result, 'warning');
    return false;
  }  



  
  function get_transactionid($order_id) {
    $transaction_query = tep_db_query("select cc_transactionid from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "'");
    $transaction = tep_db_fetch_array($transaction_query);
    return $transaction['cc_transactionid'];    
  }
?>
