<?php
/*
  checkout_quickpay.php
  
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2005 Jakob Hy Biegel

  Released under the GNU General Public License
*/
  include('includes/application_top.php');

// avoid hack attempts during the checkout procedure by checking the internal cartID
  if (isset($cart->cartID) && tep_session_is_registered('cartID')) {
    if ($cart->cartID != $cartID) {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
    }
  }

if (MODULE_PAYMENT_QUICKPAY_LOCALFORM == 'True') {
  // Don't do this checks on remote payment-forms
  
  // if the customer is not logged on, redirect them to the login page
  if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_PAYMENT));
    tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
  }
  if (!tep_session_is_registered('sendto')) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
  }

  if ( (tep_not_null(MODULE_PAYMENT_INSTALLED)) && (!tep_session_is_registered('payment')) ) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
  }  

// load selected payment module
  require(DIR_WS_CLASSES . 'payment.php');
  $payment_modules = new payment($payment);

// load the selected shipping module
  require(DIR_WS_CLASSES . 'shipping.php');
  $shipping_modules = new shipping($shipping);

  require(DIR_WS_CLASSES . 'order.php');
  $order = new order;

  require(DIR_WS_CLASSES . 'order_total.php');
  $order_total_modules = new order_total;
  $order_totals = $order_total_modules->process();
} else {
//  $qp_binary_gateway = 'https://secure.quickpay.dk/proxy.php/'; 
}

  include(DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_QUICKPAY);

  $breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
  $breadcrumb->add(NAVBAR_TITLE_2);

?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<title><?php echo TITLE; ?></title>
<?php 
if (MODULE_PAYMENT_QUICKPAY_LOCALFORM == 'False') { 
?>
<base href="<?php echo $qp_binary_gateway . (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG; ?>">
<link rel="stylesheet" type="text/css" href="<?php echo $qp_binary_gateway . HTTP_SERVER . DIR_WS_HTTP_CATALOG; ?>stylesheet.css">
<?php 
} else { 
?>
<base href="<?php echo (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG; ?>">
<link rel="stylesheet" type="text/css" href="<?php echo TEMPLATE_STYLE;?>">
<?php
}
?>  


<script language="javascript"><!--
    function check_pbscc_form() {
        // Remove all non-digits from CardNumber
        document.payment_form.cardnum.value = 
            document.payment_form.cardnum.value.replace(/(\D)+/g,"");

<?php if (isset($_GET['qpcard']) && tep_not_null($_GET['qpcard']) && $_GET['qpcard']!='Forbrugsforeningen') {
?>
        // Remove all non-digits from Control-digits
        document.payment_form.cvd.value = 
            document.payment_form.cvd.value.replace(/(\D)+/g,"");
<?php } ?>
    }
//--></script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0">
<!-- header //-->
<?php require(DIR_WS_INCLUDES . 'header.php'); 
?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="3" cellpadding="3">
  <tr>
    <td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="0" cellpadding="2">
<!-- left_navigation //-->
<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
<!-- left_navigation_eof //-->
    </table></td>
<!-- body_text //-->
    <td width="100%" valign="top">
    <?php 
    if (MODULE_PAYMENT_QUICKPAY_LOCALFORM == 'False') {
      echo tep_draw_form('payment_form', 'https://secure.quickpay.dk/quickpay_pay.php', 'post', 'autocomplete="off" onsubmit="return check_pbscc_form();"');
    } else {
      if ((PHP_VERSION < "5.0.0")) {
        echo tep_draw_form('payment_form', tep_href_link(FILENAME_CHECKOUT_TRANSACTION4, '', 'SSL'), 'post', 'onsubmit="return check_pbscc_form();"');
      } else {
        echo tep_draw_form('payment_form', tep_href_link(FILENAME_CHECKOUT_TRANSACTION5, '', 'SSL'), 'post', 'onsubmit="return check_pbscc_form();"');
      }
    }
    ?>
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td><table border="0" width="100%" cellspacing="4" cellpadding="2">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
            <td class="pageHeading" align="right"><?php echo tep_image(DIR_WS_IMAGES . 'table_background_confirmation.gif', HEADING_TITLE, HEADING_IMAGE_WIDTH, HEADING_IMAGE_HEIGHT); ?></td>
            </td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><table border="0" width="100%" cellspacing="1" cellpadding="2" class="infoBox">
          <tr class="infoBoxContents">
            <td><table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
                <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
              </tr>
              <?php
                  // show cc-payment specific data 
                  $process_button_string = '<tr>';
                  if (MODULE_PAYMENT_QUICKPAY_LOCALFORM == 'False') {
/*
                    $process_button_string .= '<td class="main"><b>' . ORDER_NUMBER . '</b></td>';
                    $process_button_string .= '<td class="main">###ORDERNUM###</td>';
                    $process_button_string .= '</tr><tr>';
*/
                    $process_button_string .= '<td class="main"><b>' . ORDER_AMOUNT . '</b></td>';
                    $process_button_string .= '<td class="main">###AMOUNT_FORMATTED### ###CURRENCY###</td>';
                    $process_button_string .= '</tr><tr>';
                    $process_button_string .= '<td class="main"><b>' . CARD_NUMBER . '</b></td>';
                    $process_button_string .= '<td class="main">' . tep_draw_input_field('cardnum', '', 'autocomplete="off" size="22"') . '</td>';
                    $process_button_string .= '</tr><tr>';
                    $process_button_string .= '<td class="main"><b>' . EXPIRE_DATE . '</b></td>';
                    $process_button_string .= '<td class="main"><select name="month">###MONTH_OPTIONS###</select>&nbsp;<select name="year">###YEAR_OPTIONS###</select> ' . EXPIRE_DATE_HINT . '</td>';
                    $process_button_string .= '</tr><tr>';
                    if (isset($_GET['qpcard']) && tep_not_null($_GET['qpcard']) && $_GET['qpcard']=='Forbrugsforeningen') {
                      $process_button_string .= '<td colspan="2" class="main"><br>' . USABLE_CARDS . '<br><br>' . tep_image(DIR_WS_IMAGES . 'forbrugsforeningen_logo.gif') . '</td>';
                    } else {
                      $process_button_string .= '<td class="main"><b>' . CVC . '</b></td>';
                      $process_button_string .= '<td class="main">' . tep_draw_input_field('cvd', '', 'autocomplete="off" size="3" maxlength="3"') . '&nbsp;' . CVC_HINT . '</td>';
                      $process_button_string .= '</tr><tr>';
                      $process_button_string .= '<td colspan="2" class="main"><br>###CARDS###</td>';
                    }
                  } else {

                  // Local form
                    $order_amount = $$payment->calculate($order->info['total'], true, $order->info['currency'], $order->info['currency_value'], '.', '');
                    $currency_code = $order->info['currency'];
                    $order_amount_text = $$payment->calculate($order_amount, false, $currency_code) . ' ' . $currency_code;
                    for ($i=1; $i<13; $i++) {
                        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => sprintf('%02d', $i));
                    }
                    $today = getdate(); 
                    for ($i=$today['year']; $i < $today['year']+20; $i++) {
                        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%y',mktime(0,0,0,1,1,$i)));
                    }
/*
                    $process_button_string .= '<td class="main"><b>' . ORDER_NUMBER . '</b></td>';
                    $process_button_string .= '<td class="main">' . strval($insert_order_id) . tep_draw_hidden_field("OrderNumber", $insert_order_id) . '</td>';
                    $process_button_string .= '</tr><tr>';
*/
                    $process_button_string .= '<td class="main"><b>' . ORDER_AMOUNT . '</b></td>';
                    $process_button_string .= '<td class="main">' . $order_amount_text;
                    $process_button_string .= tep_draw_hidden_field('amount', 100*$order_amount) . tep_draw_hidden_field('currency', $currency_code) . '</td>';
                    $process_button_string .= '</tr><tr>';
                    $process_button_string .= '</tr><tr>';
                    $process_button_string .= '<td class="main"><b>' . CARD_NUMBER . '</b></td>';
                    $process_button_string .= '<td class="main">' . tep_draw_input_field('cardnum', '', 'autocomplete="off" size="22"') . '</td>';
                    $process_button_string .= '</tr><tr>';
                    $process_button_string .= '<td class="main"><b>' . EXPIRE_DATE . '</b></td>';
                    $process_button_string .= '<td class="main">' . tep_draw_pull_down_menu('month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('year', $expires_year) . '&nbsp;' . EXPIRE_DATE_HINT . '</td>';
                    $process_button_string .= '</tr><tr>';
                      if (isset($_GET['qpcard']) && tep_not_null($_GET['qpcard']) && $_GET['qpcard']=='Forbrugsforeningen') {
                      $process_button_string .= '<td colspan="2" class="main"><br>' . USABLE_CARDS . '<br><br>' . tep_image(DIR_WS_IMAGES . 'forbrugsforeningen_logo.gif') . '</td>';
                      $process_button_string .= tep_draw_hidden_field('cvd', ''); // Send empy CVD to prevent missing CVD bug in checkout_transaction4.php
                    } else {
                      $process_button_string .= '<td class="main"><b>' . CVC . '</b></td>';
                      $process_button_string .= '<td class="main">' . tep_draw_input_field('cvd', '', 'autocomplete="off" size="3" maxlength="3"') . '&nbsp;' . CVC_HINT . '</td>';
                    }
                  }
                  $process_button_string .= '</tr>';
                  echo $process_button_string;
              ?>
              <tr>
                <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
              </tr>
            </table></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>
      <tr>
        <td><table border="0" width="100%" cellspacing="1" cellpadding="2" class="infoBox">
          <tr class="infoBoxContents">
            <td><table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
                <td width="10"><?php echo tep_draw_separator('pixel_trans.gif', '10', '1'); ?></td>
                <td class="main"><b><?php echo TITLE_CONTINUE_CHECKOUT_PROCEDURE . '</b><br>' . TEXT_CONTINUE_CHECKOUT_PROCEDURE; ?></td>
                <td class="main" align="right"><?php echo tep_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE); ?></td>
                <td width="10"><?php echo tep_draw_separator('pixel_trans.gif', '10', '1'); ?></td>
              </tr>
            </table></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>
      <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td width="20%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
              <tr>
                <td width="50%" align="right"><?php echo tep_draw_separator('pixel_silver.gif', '1', '5'); ?></td>
                <td width="50%"><?php echo tep_draw_separator('pixel_silver.gif', '100%', '1'); ?></td>
              </tr>
            </table></td>
            <td width="20%"><?php echo tep_draw_separator('pixel_silver.gif', '100%', '1'); ?></td>
            <td width="20%"><?php echo tep_draw_separator('pixel_silver.gif', '100%', '1'); ?></td>
            <td width="20%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
              <tr>
                <td width="50%"><?php echo tep_draw_separator('pixel_silver.gif', '100%', '1'); ?></td>
                <td><?php echo tep_image(DIR_WS_IMAGES . 'checkout_bullet.gif'); ?></td>
                <td width="50%"><?php echo tep_draw_separator('pixel_silver.gif', '100%', '1'); ?></td>
              </tr>
            </table></td>
            <td width="20%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
              <tr>
                <td width="50%"><?php echo tep_draw_separator('pixel_silver.gif', '100%', '1'); ?></td>
                <td width="50%"><?php echo tep_draw_separator('pixel_silver.gif', '1', '5'); ?></td>
              </tr>
            </table></td>
          </tr>
          <tr>
            <td align="center" width="25%" class="checkoutBarFrom"><?php echo '<a href="' . tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL') . '" class="checkoutBarFrom">' . CHECKOUT_BAR_DELIVERY . '</a>'; ?></td>
            <td align="center" width="25%" class="checkoutBarFrom"><?php echo '<a href="' . tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL') . '" class="checkoutBarFrom">' . CHECKOUT_BAR_PAYMENT . '</a>'; ?></td>
            <td align="center" width="25%" class="checkoutBarFrom"><?php echo CHECKOUT_BAR_CONFIRMATION; ?></td>
            <td align="center" width="25%" class="checkoutBarCurrent"><?php echo CHECKOUT_BAR_ONLINE_PAYMENT; ?></td>
            <td align="center" width="25%" class="checkoutBarTo"><?php echo CHECKOUT_BAR_FINISHED; ?></td>
          </tr>
        </table></td>
      </tr>
    </table></form></td>
<!-- body_text_eof //-->
    <td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="0" cellpadding="2">
<!-- right_navigation //-->
<?php require(DIR_WS_INCLUDES . 'column_right.php'); ?>
<!-- right_navigation_eof //-->
    </table></td>
  </tr>
</table>
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>