<?php
/*
  checkout_transaction4.php

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2005 Jakob Hy Biegel

  Released under the GNU General Public License
  
  Process online payment using Quickpay payment class.
*/

  include('includes/application_top.php');

// if the customer is not logged on, redirect them to the login page
  if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_PAYMENT));
    tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
  }

// avoid hack attempts during the checkout procedure by checking the internal cartID
  if (isset($cart->cartID) && tep_session_is_registered('cartID')) {
    if ($cart->cartID != $cartID) {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
    }
  }

  
  if (!isset($HTTP_POST_VARS['cardnum']) || 
      !isset($HTTP_POST_VARS['month']) || 
      !isset($HTTP_POST_VARS['year']) || 
      !isset($HTTP_POST_VARS['cvd']) ||
      !isset($HTTP_POST_VARS['amount']) ||
      !isset($HTTP_POST_VARS['currency'])) {
    tep_redirect(tep_href_link(FILENAME_QUICKPAY_DECLINE, '', 'SSL'));
  }
  
  // load selected payment module
  require(DIR_WS_CLASSES . 'quickpay4.php');

  $qp = new quickpay;
  // Set values
  $qp->set_msgtype('1100');
  $qp->set_md5checkword(MODULE_PAYMENT_QUICKPAY_MD5WORD);
  $qp->set_merchant(MODULE_PAYMENT_QUICKPAY_SHOPID);
  $qp->set_posc('K00500K00130');
  $qp->set_cardnumber($HTTP_POST_VARS['cardnum']);
  $qp->set_expirationdate($HTTP_POST_VARS['year'] . $HTTP_POST_VARS['month']);
  $qp->set_cvd($HTTP_POST_VARS['cvd']);
  $qp->set_ordernum(sprintf('%04d', $order_id)); // MUST at least be of length 4
  $qp->set_amount($HTTP_POST_VARS['amount']);
  $qp->set_currency($HTTP_POST_VARS['currency']);
  // Set some custom variables
//  $qp->add_customVars('Name1', 'Value1');
//  $qp->add_customVars('Name2', 'Value2');
  // Commit the authorization
  $eval = $qp->authorize();

  if ($eval) {
      if ($eval['qpstat'] === '000') {
          // The authorization was completed
          // First store the transaciton_id with the order in the database
          $sql_data_array = array('cc_transactionid' => urldecode($eval['transaction']));
          tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . tep_db_input((int)$order_id));
          tep_redirect(tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'));
      } else {
          // An error occured with the authorization

          // Store the error with the order in the database
          if ($eval['qpstat'] == '008') {
            $sql_data_array = array('cc_transactionid' => tep_db_input($eval['qpstatmsg']));
          } else {
            $sql_data_array = array('cc_transactionid' => tep_db_input((int)$eval['qpstat']));
          }  
          tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . tep_db_input((int)$order_id));
      }
      tep_redirect(tep_href_link(FILENAME_QUICKPAY_DECLINE, '', 'SSL'));
  } 

  // Communication error
  $sql_data_array = array('cc_transactionid' => '2');
  tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . tep_db_input((int)$order_id));
  tep_redirect(tep_href_link(FILENAME_QUICKPAY_DECLINE, '', 'SSL'));

  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
