<?php
/*

  $Id: quickpay.php,v 1.0.0.0 2007/11/29 13:41:11 eversun Exp $

  CRE Loaded, Open Source E-Commerce Solutions

  http://www.creloaded.com

  Copyright (c) 2007 CRE Loaded
  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License

*/

  class quickpay {
    var $code, $title, $description, $enabled, $order_id;

// class constructor
    function quickpay() {
      global $order;

      $this->code = 'quickpay';
      $this->title = MODULE_PAYMENT_QUICKPAY_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_QUICKPAY_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_QUICKPAY_SORT_ORDER;
      $this->email_footer = MODULE_PAYMENT_QUICKPAY_TEXT_EMAIL_FOOTER;
      $this->enabled = ((MODULE_PAYMENT_QUICKPAY_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_QUICKPAY_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_QUICKPAY_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_QUICKPAY_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_QUICKPAY_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
            '     var qp_card_value = null;' . "\n" .
            '      if (document.checkout_payment.qp_card.length) {' . "\n" .
            '        for (var i=0; i<document.checkout_payment.qp_card.length; i++) {' . "\n" .
            '          if (document.checkout_payment.qp_card[i].checked) {' . "\n" .
            '            qp_card_value = document.checkout_payment.qp_card[i].value;' . "\n" .
            '          }' . "\n" .
            '        }' . "\n" .
            '      } else if (document.checkout_payment.qp_card.checked) {' . "\n" .
            '        qp_card_value = document.checkout_payment.qp_card.value;' . "\n" .
            '      } else if (document.checkout_payment.qp_card.value) {' . "\n" .
            '        qp_card_value = document.checkout_payment.qp_card.value;' . "\n" .
            '        document.checkout_payment.qp_card.checked=true;' . "\n" .    
            '      }' . "\n" .
            '    if (qp_card_value == null) {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_QUICKPAY_TEXT_SELECT_CARD . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '  }' . "\n";
      return $js;
    }

    function selection() {
      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array());
                         
      if (true) {
        $selection['fields'][] = array('title' => MODULE_PAYMENT_QUICKPAY_CREDITCARD_TEXT,
                                       'field' => tep_draw_radio_field('qp_card', 'Creditcard'));
      }
      if (MODULE_PAYMENT_QUICKPAY_FORBRUGSFORENINGEN == 'True') {
        $selection['fields'][] = array('title' => MODULE_PAYMENT_QUICKPAY_FORBRUGSFORENINGEN_TEXT,
                                       'field' => tep_draw_radio_field('qp_card', 'Forbrugsforeningen'));
      }                              
      return $selection;
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $_POST;
      
      switch ($_POST['qp_card']) {
        case 'Creditcard':
          $confirmation = array('title' => MODULE_PAYMENT_QUICKPAY_TEXT_DESCRIPTION . ': ' . MODULE_PAYMENT_QUICKPAY_CREDITCARD_TEXT);
          break;
        case 'Forbrugsforeningen':
          $confirmation = array('title' => MODULE_PAYMENT_QUICKPAY_TEXT_DESCRIPTION . ': ' . MODULE_PAYMENT_QUICKPAY_FORBRUGSFORENINGEN_TEXT);
          break;
      }
      
      return $confirmation;
    }

    function process_button() {
      global $_POST;
      $process_button_string = tep_draw_hidden_field('qp_card', $_POST['qp_card']);
      return $process_button_string;
    }

    function before_process() {
      global $_POST, $order, $currencies, $language, $order_id, $order_total_modules;            

      // We need order_id to pass to the gateway
      // But we do not have the order_id at this moment. 
      // So instead we create the order_id now and bypass the usual checkout_process.php function
      if (!tep_session_is_registered('order_id')) {
        // Assign order_id
        tep_session_register('order_id');
        $order_id = $this->create_order();
      } else {
        // Is transation_id set then we already been at the payment form, and we just return.       
        $transaction_query = tep_db_query("SELECT cc_transactionid FROM " . TABLE_ORDERS . " WHERE orders_id = '" . tep_db_input($order_id) . "'");
        $transaction = tep_db_fetch_array($transaction_query);
        if (isset($transaction['cc_transactionid']) && tep_not_null($transaction['cc_transactionid'])) {
          return;
        }
      }      
      $qp_order_id = sprintf('%04d', $order_id);
      
      if (MODULE_PAYMENT_QUICKPAY_LOCALFORM == 'False') {
        // Calculate the total order amount for the order (the same way as in checkout_process.php)
//        require(DIR_WS_CLASSES . 'order_total.php');
//        $order_total_modules = new order_total;
//        $order_total_modules->process();
  
        // Here we want to call the Quickpay payment window.
        $quickpay_language = ($language == "danish") ? "da" : "en";
        $order_amount = 100*$this->calculate($order->info['total'], true, $order->info['currency'], $order->info['currency_value'], '.', '');
        $currency_code = $order->info['currency'];
        $merchant_id = MODULE_PAYMENT_QUICKPAY_SHOPID;
        $ok_page = tep_href_link(FILENAME_CHECKOUT_PROCESS_QUICKPAY, '', 'SSL');
        $error_page = tep_href_link(FILENAME_QUICKPAY_DECLINE, '', 'SSL');
        $result_page = tep_href_link(FILENAME_QUICKPAY_RESULT, '', 'SSL');
        $cci_page = tep_href_link(FILENAME_CHECKOUT_QUICKPAY, 'language=' . $quickpay_language . '&currency=' . $currency_code . '&qpcard=' . $_POST['qp_card'], 'SSL');
        $md5word = MODULE_PAYMENT_QUICKPAY_MD5WORD;
        $md5check = md5($qp_order_id.$order_amount.$currency_code.$merchant_id.$ok_page.$error_page.$result_page.$cci_page.$md5word);

        echo '<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
              <html ' . HTML_PARAMS . '>
              <head>
                <title>' . STORE_NAME . '</title>
                <meta http-equiv="Content-Type" content="text/html; charset='. CHARSET . '">
                <style type="text/css">
                  body {background-color:#FFFFFF;}
                  body, td, div {font-family: verdana, arial, sans-serif;}
                </style>
              </head>
              <body onload="return document.quickpay_payment_info.submit();">' . "\n";
        echo tep_draw_form('quickpay_payment_info', 'https://secure.quickpay.dk/quickpay.php', 'post'/*, 'target="_blank"'*/) . "\n";
        echo tep_draw_hidden_field('language', $quickpay_language) . "\n" .
             tep_draw_hidden_field('autocapture', '0') . "\n" .
             tep_draw_hidden_field('ordernum', $qp_order_id) . "\n" .
             tep_draw_hidden_field('merchant', $merchant_id) . "\n" .
             tep_draw_hidden_field('amount', $order_amount). "\n" . 
             tep_draw_hidden_field('currency', $currency_code) . "\n" .
             tep_draw_hidden_field('okpage', $ok_page) . "\n" .
             tep_draw_hidden_field('errorpage', $error_page) . "\n" .
             tep_draw_hidden_field('resultpage', $result_page) . "\n" .
             tep_draw_hidden_field('ccipage', $cci_page) . "\n" .
             tep_draw_hidden_field('md5check', $md5check);
        echo tep_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE) . '</form>'  . "\n";
        echo MODULE_PAYMENT_QUICKPAY_TEXT_SPLASH_MESSAGE . "\n";
        echo '</body></html>';
        exit();
      } else {
        // Here we want to show the Quickpay payment window.
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_QUICKPAY, 'qpcard=' . $_POST['qp_card'], 'SSL'));
      }
    }

    function after_process() {
      tep_session_unregister('order_id');
    }

    function get_error() {
      global $order_id;
      $transaction_query = tep_db_query("select cc_transactionid from " . TABLE_ORDERS . " where orders_id = '" . $order_id . "'");
      $transaction = tep_db_fetch_array($transaction_query);
      $errorcode = $transaction['cc_transactionid'];
      
      // Remove transactionid for declined payment
      $sql_data_array = array('cc_transactionid' => NULL);
      tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = '. $order_id);

      switch (urldecode($errorcode)) {
          case 1: return ERROR_TRANSACTION_DECLINED;
          case 2: return ERROR_COMMUNICATION_FAILURE;
          case 3: return ERROR_CARD_EXPIRED; 
          case 4: return ERROR_ILLEGAL_TRANSACTION;
          case 5: return ERROR_TRANSACTION_EXPIRED; // NO TRANSLATION!!!
          case 6: return ERROR_COMMUNICATION_FAILURE;
          case 7: return ERROR_SYSTEM_FAILURE;
          default: return urldecode(nl2br($errorcode)); //ERROR_CARDNO_NOT_VALID;
      }
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_QUICKPAY_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable QuickPay Module', 'MODULE_PAYMENT_QUICKPAY_STATUS', 'True', 'Do you want to accept Quickpay payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_QUICKPAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Quickpay Shop Id', 'MODULE_PAYMENT_QUICKPAY_SHOPID', '', 'Enter shopid (merchant id)', '6', '6', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Set MD5 Word', 'MODULE_PAYMENT_QUICKPAY_MD5WORD', '', 'The MD5 word for your Quickpay Payment Gateway', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Local Payment Form', 'MODULE_PAYMENT_QUICKPAY_LOCALFORM', 'False', 'True if your payment-submiting form is located on your own secure webserver. False if the form is called through a secure payment-gateway', '6', '5', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Forbrugsforeningen Payments', 'MODULE_PAYMENT_QUICKPAY_FORBRUGSFORENINGEN', 'False', 'True if want to accept payments from Forbrugsforeningen', '6', '6', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_QUICKPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_QUICKPAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Captured Order Status', 'MODULE_PAYMENT_QUICKPAY_CAPTURED_ORDER_STATUS_ID', '0', 'Set the status of captured orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Canceled Order Status', 'MODULE_PAYMENT_QUICKPAY_CANCELED_ORDER_STATUS_ID', '0', 'Set the status of canceled orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      
      if (!$this->has_field(TABLE_ORDERS, 'cc_transactionid')) {
        tep_db_query("ALTER TABLE orders ADD cc_transactionid VARCHAR( 64 ) NULL default 'NULL'; ");
      }
    }
    
    function has_field($table, $field) {
      $fields_query = tep_db_query("show fields from " . $table);
      while ( $fields = tep_db_fetch_array($fields_query) ) {
        if ($fields['Field'] == $field) {
          return true;
          break;
        }
      }
      return false;
    }
    
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      
//      if ($this->has_field(TABLE_ORDERS, 'cc_transactionid')) {
//        tep_db_query("ALTER TABLE orders DROP cc_transactionid;");
//      }
    }

    function keys() {
      return array('MODULE_PAYMENT_QUICKPAY_STATUS', 'MODULE_PAYMENT_QUICKPAY_ZONE', 'MODULE_PAYMENT_QUICKPAY_SHOPID', 'MODULE_PAYMENT_QUICKPAY_MD5WORD', 'MODULE_PAYMENT_QUICKPAY_LOCALFORM', 'MODULE_PAYMENT_QUICKPAY_FORBRUGSFORENINGEN', 'MODULE_PAYMENT_QUICKPAY_ORDER_STATUS_ID', 'MODULE_PAYMENT_QUICKPAY_SORT_ORDER', 'MODULE_PAYMENT_QUICKPAY_CAPTURED_ORDER_STATUS_ID', 'MODULE_PAYMENT_QUICKPAY_CANCELED_ORDER_STATUS_ID');
    }

    function create_order() {
      global $customer_id;

      // Create an entry in the orders-table in order to get an order-id we can use
      // This entry only works as a reservation.
      // If no other data is added, the order will not be displayed in OsCommerce
      $sql_data_array = array('customers_id' => $customer_id,
                              'date_purchased' => 'now()', 
                              'orders_status' => 0);
      tep_db_perform(TABLE_ORDERS, $sql_data_array);
      return tep_db_insert_id();
    }
    
    function calculate($number, $calculate_currency_value = true, $currency_type = '', $currency_value = '', $currency_decimal_point = '', $currency_thousands_point = '@') {
      global $currency, $currencies;

      if (empty($currency_type)) $currency_type = $currency;
      if (empty($currency_decimal_point)) $currency_decimal_point = $currencies->currencies[$currency_type]['decimal_point'];
      if ($currency_thousands_point == '@') $currency_thousands_point = $currencies->currencies[$currency_type]['thousands_point'];
      
      $number_display = $number; 
      if ($calculate_currency_value) {
          $rate = (tep_not_null($currency_value)) ? $currency_value : $currencies->currencies[$currency_type]['value'];
          $number_display = $number * $rate;
      }
      return number_format($number_display, $currencies->currencies[$currency_type]['decimal_places'], $currency_decimal_point, $currency_thousands_point); 
    }
  }  
?>